#####################################################################
## Fundamental operations on values
`!` <- function(x) .Primitive("not")
`-uni` <- function(x) .Primitive("-uni")
typeof <- function (x) .Primitive("typeof")


#nargs <- function ()  .Primitive("nargs")



#inherits <- function (x, what, which = FALSE) .Internal(inherits(x, what, which))
#UseMethod <- function (generic, object)  .Primitive("UseMethod")



#storage.mode <- function (x) switch(tx <- typeof(x), closure = , builtin = , special = "function", tx)    
    
switch <- function (EXPR, ...)  .Primitive("switch")    



#####################################################################
##
stop <- function (..., call. = TRUE, domain = NULL) 
{
	.Primitive("stop")
#    args <- list(...)
#    if (length(args) == 1L && inherits(args[[1L]], "condition")) {
#        cond <- args[[1L]]
#        if (nargs() > 1L) 
#            warning("additional arguments ignored in stop()")
#        message <- conditionMessage(cond)
#        call <- conditionCall(cond)
#        .Internal(.signalCondition(cond, message, call))
#        .Internal(.dfltStop(message, call))
#    }
#    else .Internal(stop(as.logical(call.), .makeMessage(..., 
#        domain = domain)))
}





#####################################################################
##
warning <- function (..., call. = TRUE, immediate. = FALSE, domain = NULL) 
{
	.Primitive("warning")
#    args <- list(...)
#    if (length(args) == 1L && inherits(args[[1L]], "condition")) {
#        cond <- args[[1L]]
#        if (nargs() > 1L) 
#            cat(gettext("additional arguments ignored in warning()"), 
#                "\n", sep = "", file = stderr())
#        message <- conditionMessage(cond)
#        call <- conditionCall(cond)
#        withRestarts({
#            .Internal(.signalCondition(cond, message, call))
#            .Internal(.dfltWarn(message, call))
#        }, muffleWarning = function() NULL)
#        invisible(message)
#    }
#    else .Internal(warning(as.logical(call.), as.logical(immediate.), 
#        .makeMessage(..., domain = domain)))
}





#####################################################################
##
ifelse <- function (test, yes, no) 
{
    if (is.atomic(test)) 
        storage.mode(test) <- "logical"
    else test <- if (isS4(test)) 
        as(test, "logical")
    else as.logical(test)
    ans <- test
    ok <- !(nas <- is.na(test))
    if (any(test[ok])) 
        ans[test & ok] <- rep(yes, length.out = length(ans))[test & ok]
    if (any(!test[ok])) 
        ans[!test & ok] <- rep(no, length.out = length(ans))[!test & ok]
    ans[nas] <- NA
    ans
}

    

